/**
 * These handlers assume that the number of "setup" and "teardown" requests to
 * `/_pactSetup` are always sequential and balanced, i.e. if 3 "setup" actions
 * are received prior to an interaction being executed, then 3 "teardown"
 * actions will be received after that interaction has ended.
 */
import { RequestHandler } from 'express';
import { Hook } from './types';
export type HooksState = {
    setupCounter: number;
};
export declare const registerHookStateTracking: (hooksState: HooksState) => RequestHandler;
export declare const registerBeforeHook: (beforeEach: Hook, hooksState: HooksState) => RequestHandler;
export declare const registerAfterHook: (afterEach: Hook, hooksState: HooksState) => RequestHandler;
